#!/usr/bin/env python
# -*- coding: utf-8 -*-
from roller_constant_key import Option as ok
from roller_port_preview import PortPreview
from roller_widget_node import Piece


class PortSubFrame(PortPreview):
    """Is a display container for Frame Preset."""
    window_key = "Frame"

    def __init__(self, d, g):
        """
        g: OptionButton
            Is responsible.
        """
        PortPreview.__init__(self, d, g)

    def _draw(self, box):
        """
        Draw the Preset option group.

        box: GTK container
            to receive group
        """
        self.draw_group(Piece(ok.FRAME_METAL, box, self.safe.any_group.item))

    def draw(self):
        """Draw Widget."""
        self.draw_column((self._draw, self.draw_random_process_group))

    def get_group_value(self):
        """
        Get the Preset value.

        Return: dict
            Bump Preset
        """
        return self.preset.get_a()
