#!/usr/bin/env python
# -*- coding: utf-8 -*-
from roller_constant_for import Signal as si
from roller_one_the import The
import gimpfu as fu
import gobject

pdb = fu.pdb


class ViewImage(gobject.GObject, object):
    """Use to create and change the render image."""
    __gsignals__ = si.IMAGE_D

    def __init__(self):
        """Init for a new View image."""
        self._image = self.has_image = self._display = None
        gobject.GObject.__init__(self)

    def get_image(self):
        """
        Fetch the View's GIMP image.

        Return: GIMP image or None
        """
        return self._image

    def image(self):
        """
        Get the View's image. If it doesn't exist, then create one first.

        Return: GIMP image
            Is from a View op or a new image made due to size change.
        """
        if self._image:
            return self._image
        return self.new_image(*The.view.view_size)

    def new_image(self, w, h):
        """
        Get the View's image. If it doesn't exist, then create one first.

        w, h: int
            new image size

        Return: GIMP image
            Is from a View op or a new image made due to size change.
        """
        if self._image:
            # The View image is the wrong size.
            self.emit(si.CLOSE_VIEW_IMAGE, self._image)
            pdb.gimp_display_delete(self._display)

        j = self._image = pdb.gimp_image_new(w, h, fu.RGB)

        # Show in GIMP:
        self._display = pdb.gimp_display_new(j)

        # Turn off undo functionality to save
        # memory and to improve performance.
        pdb.gimp_image_undo_disable(j)

        self.has_image = True
        return j


# Register the custom signals.
gobject.type_register(ViewImage)
